/*
 * Copyright (c) 2000-2003 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * This file contains Original Code and/or Modifications of Original Code
 * as defined in and that are subject to the Apple Public Source License
 * Version 2.0 (the 'License'). You may not use this file except in
 * compliance with the License. Please obtain a copy of the License at
 * http://www.opensource.apple.com/apsl/ and read it before using this
 * file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 * Please see the License for the specific language governing rights and
 * limitations under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */

/*
 * This file is automatically generated
 * DO NOT EDIT!
 */

/*
 * Note: For Cocoa/Obj-C/Foundation programs accessing these preference
 *       keys you may want to consider the following:
 *
 *       #define SCSTR(s) (NSString *)CFSTR(s)
 *       #import <SystemConfiguration/SystemConfiguration.h>
 */

#ifndef _SCSCHEMADEFINITIONS_10_1_H
#define _SCSCHEMADEFINITIONS_10_1_H

#ifndef  SCSTR
#include <CoreFoundation/CFString.h>
#define  SCSTR(s) CFSTR(s)
#endif

/*
 * Reserved Keys
 */
#define kSCResvLink                              SCSTR("__LINK__")                        /* CFString */
#define kSCResvInactive                          SCSTR("__INACTIVE__")                   

/*
 * Generic Keys
 */
#define kSCPropInterfaceName                     SCSTR("InterfaceName")                   /* CFString */
#define kSCPropMACAddress                        SCSTR("MACAddress")                      /* CFString */
#define kSCPropUserDefinedName                   SCSTR("UserDefinedName")                 /* CFString */
#define kSCPropVersion                           SCSTR("Version")                         /* CFString */

/*
 * Preference Keys
 */
#define kSCPrefCurrentSet                        SCSTR("CurrentSet")                      /* CFString */
#define kSCPrefNetworkServices                   SCSTR("NetworkServices")                 /* CFDictionary */
#define kSCPrefSets                              SCSTR("Sets")                            /* CFDictionary */
#define kSCPrefSystem                            SCSTR("System")                          /* CFDictionary */

/*
 * Component Keys
 */
#define kSCCompNetwork                           SCSTR("Network")                        
#define kSCCompService                           SCSTR("Service")                        
#define kSCCompGlobal                            SCSTR("Global")                         
#define kSCCompHostNames                         SCSTR("HostNames")                      
#define kSCCompInterface                         SCSTR("Interface")                      
#define kSCCompSystem                            SCSTR("System")                         
#define kSCCompUsers                             SCSTR("Users")                          

/*
 * Regex key which matches any component
 */
#define kSCCompAnyRegex                          SCSTR("[^/]+")                          

/*
 * Network Entity Keys
 */
#define kSCEntNetAirPort                         SCSTR("AirPort")                         /* CFDictionary */
#define kSCEntNetAppleTalk                       SCSTR("AppleTalk")                       /* CFDictionary */
#define kSCEntNetDHCP                            SCSTR("DHCP")                            /* CFDictionary */
#define kSCEntNetDNS                             SCSTR("DNS")                             /* CFDictionary */
#define kSCEntNetEthernet                        SCSTR("Ethernet")                        /* CFDictionary */
#define kSCEntNetFireWire                        SCSTR("FireWire")                        /* CFDictionary */
#define kSCEntNetInterface                       SCSTR("Interface")                       /* CFDictionary */
#define kSCEntNetIPv4                            SCSTR("IPv4")                            /* CFDictionary */
#define kSCEntNetIPv6                            SCSTR("IPv6")                            /* CFDictionary */
#define kSCEntNetL2TP                            SCSTR("L2TP")                            /* CFDictionary */
#define kSCEntNetLink                            SCSTR("Link")                            /* CFDictionary */
#define kSCEntNetModem                           SCSTR("Modem")                           /* CFDictionary */
#define kSCEntNetNetInfo                         SCSTR("NetInfo")                         /* CFDictionary */
// #define kSCEntNetNIS                          SCSTR("???") */                          /* RESERVED FOR FUTURE USE */
#define kSCEntNetPPP                             SCSTR("PPP")                             /* CFDictionary */
#define kSCEntNetPPPoE                           SCSTR("PPPoE")                           /* CFDictionary */
#define kSCEntNetPPPSerial                       SCSTR("PPPSerial")                       /* CFDictionary */
#define kSCEntNetPPTP                            SCSTR("PPTP")                            /* CFDictionary */
#define kSCEntNetProxies                         SCSTR("Proxies")                         /* CFDictionary */
#define kSCEntNet6to4                            SCSTR("6to4")                            /* CFDictionary */

/*
 * kSCCompNetwork Properties
 */
#define kSCPropNetOverridePrimary                SCSTR("OverridePrimary")                 /* CFNumber (0 or 1) */
#define kSCPropNetServiceOrder                   SCSTR("ServiceOrder")                    /* CFArray[CFString] */
#define kSCPropNetPPPOverridePrimary             SCSTR("PPPOverridePrimary")              /* CFNumber (0 or 1) */

/*
 * kSCCompNetworkInterface Properties
 */
#define kSCPropNetInterfaces                     SCSTR("Interfaces")                      /* CFArray[CFString] */

/*
 * kSCCompNetworkHostNames Properties
 */
#define kSCPropNetLocalHostName                  SCSTR("LocalHostName")                   /* CFString */

/*
 * kSCEntNetAirPort (Hardware) Entity Keys
 */
#define kSCPropNetAirPortAllowNetCreation        SCSTR("AllowNetCreation")                /* CFNumber (0 or 1) */
#define kSCPropNetAirPortAuthPassword            SCSTR("AuthPassword")                    /* CFData */
#define kSCPropNetAirPortAuthPasswordEncryption  SCSTR("AuthPasswordEncryption")          /* CFString */
#define kSCPropNetAirPortJoinMode                SCSTR("JoinMode")                        /* CFString */
#define kSCPropNetAirPortPowerEnabled            SCSTR("PowerEnabled")                    /* CFNumber (0 or 1) */
#define kSCPropNetAirPortPreferredNetwork        SCSTR("PreferredNetwork")                /* CFString */
#define kSCPropNetAirPortSavePasswords           SCSTR("SavePasswords")                   /* CFNumber (0 or 1) */

/* kSCPropNetAirPortJoinMode values */
#define kSCValNetAirPortJoinModeAutomatic        SCSTR("Automatic")                      
#define kSCValNetAirPortJoinModePreferred        SCSTR("Preferred")                      
#define kSCValNetAirPortJoinModeRecent           SCSTR("Recent")                         
#define kSCValNetAirPortJoinModeStrongest        SCSTR("Strongest")                      

/* kSCPropNetAirPortPasswordEncryption values */
#define kSCValNetAirPortAuthPasswordEncryptionKeychain SCSTR("Keychain")                       

/*
 * kSCEntNetAppleTalk Entity Keys
 */
#define kSCPropNetAppleTalkComputerName          SCSTR("ComputerName")                    /* CFString */
#define kSCPropNetAppleTalkComputerNameEncoding  SCSTR("ComputerNameEncoding")            /* CFNumber */
#define kSCPropNetAppleTalkConfigMethod          SCSTR("ConfigMethod")                    /* CFString */
#define kSCPropNetAppleTalkDefaultZone           SCSTR("DefaultZone")                     /* CFString */
#define kSCPropNetAppleTalkNetworkID             SCSTR("NetworkID")                       /* CFNumber */
#define kSCPropNetAppleTalkNetworkRange          SCSTR("NetworkRange")                    /* CFArray[CFNumber] */
#define kSCPropNetAppleTalkNodeID                SCSTR("NodeID")                          /* CFNumber */
#define kSCPropNetAppleTalkSeedNetworkRange      SCSTR("SeedNetworkRange")                /* CFArray[CFNumber] */
#define kSCPropNetAppleTalkSeedZones             SCSTR("SeedZones")                       /* CFArray[CFString] */

/* kSCPropNetAppleTalkConfigMethod values */
#define kSCValNetAppleTalkConfigMethodNode       SCSTR("Node")                           
#define kSCValNetAppleTalkConfigMethodRouter     SCSTR("Router")                         
#define kSCValNetAppleTalkConfigMethodSeedRouter SCSTR("SeedRouter")                     

/*
 * kSCEntNetDNS Entity Keys
 */
#define kSCPropNetDNSDomainName                  SCSTR("DomainName")                      /* CFString */
#define kSCPropNetDNSSearchDomains               SCSTR("SearchDomains")                   /* CFArray[CFString] */
#define kSCPropNetDNSServerAddresses             SCSTR("ServerAddresses")                 /* CFArray[CFString] */
#define kSCPropNetDNSSortList                    SCSTR("SortList")                        /* CFArray[CFString] */

/*
 * kSCEntNetEthernet (Hardware) Entity Keys
 */
#define kSCPropNetEthernetMediaSubType           SCSTR("MediaSubType")                    /* CFString */
#define kSCPropNetEthernetMediaOptions           SCSTR("MediaOptions")                    /* CFArray[CFString] */
#define kSCPropNetEthernetMTU                    SCSTR("MTU")                             /* CFNumber */

/*
 * kSCEntNetFireWire (Hardware) Entity Keys
 */
/* RESERVED FOR FUTURE USE */

/*
 * kSCEntNetInterface Entity Keys
 */
#define kSCPropNetInterfaceDeviceName            SCSTR("DeviceName")                      /* CFString */
#define kSCPropNetInterfaceHardware              SCSTR("Hardware")                        /* CFString */
#define kSCPropNetInterfaceType                  SCSTR("Type")                            /* CFString */
#define kSCPropNetInterfaceSubType               SCSTR("SubType")                         /* CFString */
#define kSCPropNetInterfaceSupportsModemOnHold   SCSTR("SupportsModemOnHold")             /* CFNumber (0 or 1) */

/* kSCPropNetInterfaceType values */
#define kSCValNetInterfaceTypeEthernet           SCSTR("Ethernet")                       
#define kSCValNetInterfaceTypeFireWire           SCSTR("FireWire")                       
#define kSCValNetInterfaceTypePPP                SCSTR("PPP")                            
#define kSCValNetInterfaceType6to4               SCSTR("6to4")                           

/* kSCPropNetServiceSubType values (for PPP) */
#define kSCValNetInterfaceSubTypePPPoE           SCSTR("PPPoE")                          
#define kSCValNetInterfaceSubTypePPPSerial       SCSTR("PPPSerial")                      
#define kSCValNetInterfaceSubTypePPTP            SCSTR("PPTP")                           
#define kSCValNetInterfaceSubTypeL2TP            SCSTR("L2TP")                           

/*
 * kSCEntNetIPv4 Entity Keys
 */
#define kSCPropNetIPv4Addresses                  SCSTR("Addresses")                       /* CFArray[CFString] */
#define kSCPropNetIPv4ConfigMethod               SCSTR("ConfigMethod")                    /* CFString */
#define kSCPropNetIPv4DHCPClientID               SCSTR("DHCPClientID")                    /* CFString */
#define kSCPropNetIPv4Router                     SCSTR("Router")                          /* CFString */
#define kSCPropNetIPv4SubnetMasks                SCSTR("SubnetMasks")                     /* CFArray[CFString] */
#define kSCPropNetIPv4DestAddresses              SCSTR("DestAddresses")                   /* CFArray[CFString] */
#define kSCPropNetIPv4BroadcastAddresses         SCSTR("BroadcastAddresses")              /* CFArray[CFString] */

/* kSCPropNetIPv4ConfigMethod values */
#define kSCValNetIPv4ConfigMethodBOOTP           SCSTR("BOOTP")                          
#define kSCValNetIPv4ConfigMethodDHCP            SCSTR("DHCP")                           
#define kSCValNetIPv4ConfigMethodINFORM          SCSTR("INFORM")                         
#define kSCValNetIPv4ConfigMethodLinkLocal       SCSTR("LinkLocal")                      
#define kSCValNetIPv4ConfigMethodManual          SCSTR("Manual")                         
#define kSCValNetIPv4ConfigMethodPPP             SCSTR("PPP")                            

/*
 * kSCEntNetIPv6 Entity Keys
 */
#define kSCPropNetIPv6Addresses                  SCSTR("Addresses")                       /* CFArray[CFString] */
#define kSCPropNetIPv6ConfigMethod               SCSTR("ConfigMethod")                    /* CFString */
#define kSCPropNetIPv6DestAddresses              SCSTR("DestAddresses")                   /* CFArray[CFString] */
#define kSCPropNetIPv6Flags                      SCSTR("Flags")                           /* CFNumber */
#define kSCPropNetIPv6PrefixLength               SCSTR("PrefixLength")                    /* CFArray[CFNumber] */
#define kSCPropNetIPv6Router                     SCSTR("Router")                          /* CFString */

/* kSCPropNetIPv6ConfigMethod values */
#define kSCValNetIPv6ConfigMethodAutomatic       SCSTR("Automatic")                      
#define kSCValNetIPv6ConfigMethodManual          SCSTR("Manual")                         
#define kSCValNetIPv6ConfigMethodRouterAdvertisement SCSTR("RouterAdvertisement")            
#define kSCValNetIPv6ConfigMethod6to4            SCSTR("6to4")                           

/*
 * kSCEntNet6to4 Entity Keys
 */
#define kSCPropNet6to4Relay                      SCSTR("Relay")                           /* CFString */

/*
 * kSCEntNetLink Entity Keys
 */
#define kSCPropNetLinkActive                     SCSTR("Active")                          /* CFBoolean */
#define kSCPropNetLinkDetaching                  SCSTR("Detaching")                       /* CFBoolean */

/*
 * kSCEntNetModem (Hardware) Entity Keys
 */
#define kSCPropNetModemConnectionScript          SCSTR("ConnectionScript")                /* CFString */
#define kSCPropNetModemConnectSpeed              SCSTR("ConnectSpeed")                    /* CFNumber */
#define kSCPropNetModemDataCompression           SCSTR("DataCompression")                 /* CFNumber (0 or 1) */
#define kSCPropNetModemDialMode                  SCSTR("DialMode")                        /* CFString */
#define kSCPropNetModemErrorCorrection           SCSTR("ErrorCorrection")                 /* CFNumber (0 or 1) */
#define kSCPropNetModemHoldCallWaitingAudibleAlert SCSTR("HoldCallWaitingAudibleAlert")     /* CFNumber (0 or 1) */
#define kSCPropNetModemHoldDisconnectOnAnswer    SCSTR("HoldDisconnectOnAnswer")          /* CFNumber (0 or 1) */
#define kSCPropNetModemHoldEnabled               SCSTR("HoldEnabled")                     /* CFNumber (0 or 1) */
#define kSCPropNetModemHoldReminder              SCSTR("HoldReminder")                    /* CFNumber (0 or 1) */
#define kSCPropNetModemHoldReminderTime          SCSTR("HoldReminderTime")                /* CFNumber */
#define kSCPropNetModemNote                      SCSTR("Note")                            /* CFString */
#define kSCPropNetModemPulseDial                 SCSTR("PulseDial")                       /* CFNumber (0 or 1) */
#define kSCPropNetModemSpeaker                   SCSTR("Speaker")                         /* CFNumber (0 or 1) */
#define kSCPropNetModemSpeed                     SCSTR("Speed")                           /* CFNumber */

/* kSCPropNetModemDialMode values */
#define kSCValNetModemDialModeIgnoreDialTone     SCSTR("IgnoreDialTone")                 
#define kSCValNetModemDialModeManual             SCSTR("Manual")                         
#define kSCValNetModemDialModeWaitForDialTone    SCSTR("WaitForDialTone")                

/*
 * kSCEntNetNetInfo Entity Keys
 */
#define kSCPropNetNetInfoBindingMethods          SCSTR("BindingMethods")                  /* CFString */
#define kSCPropNetNetInfoServerAddresses         SCSTR("ServerAddresses")                 /* CFArray[CFString] */
#define kSCPropNetNetInfoServerTags              SCSTR("ServerTags")                      /* CFArray[CFString] */
#define kSCPropNetNetInfoBroadcastServerTag      SCSTR("BroadcastServerTag")              /* CFString */

/* kSCPropNetNetInfoBindingMethods values */
#define kSCValNetNetInfoBindingMethodsBroadcast  SCSTR("Broadcast")                      
#define kSCValNetNetInfoBindingMethodsDHCP       SCSTR("DHCP")                           
#define kSCValNetNetInfoBindingMethodsManual     SCSTR("Manual")                         

/* kSCPropNetNetInfoBroadcastServerTag default value */
#define kSCValNetNetInfoDefaultServerTag         SCSTR("network")                        

/*
 * kSCEntNetNIS Entity Keys
 */
/* RESERVED FOR FUTURE USE */

/*
 * kSCEntNetPPP Entity Keys
 */
#define kSCPropNetPPPACSPEnabled                 SCSTR("ACSPEnabled")                     /* CFNumber (0 or 1) */
#define kSCPropNetPPPConnectTime                 SCSTR("ConnectTime")                     /* CFNumber */
#define kSCPropNetPPPDeviceLastCause             SCSTR("DeviceLastCause")                 /* CFNumber */
#define kSCPropNetPPPDialOnDemand                SCSTR("DialOnDemand")                    /* CFNumber (0 or 1) */
#define kSCPropNetPPPDisconnectOnIdle            SCSTR("DisconnectOnIdle")                /* CFNumber (0 or 1) */
#define kSCPropNetPPPDisconnectOnIdleTimer       SCSTR("DisconnectOnIdleTimer")           /* CFNumber */
#define kSCPropNetPPPDisconnectOnLogout          SCSTR("DisconnectOnLogout")              /* CFNumber (0 or 1) */
#define kSCPropNetPPPDisconnectOnSleep           SCSTR("DisconnectOnSleep")               /* CFNumber (0 or 1) */
#define kSCPropNetPPPDisconnectTime              SCSTR("DisconnectTime")                  /* CFNumber */
#define kSCPropNetPPPIdleReminderTimer           SCSTR("IdleReminderTimer")               /* CFNumber */
#define kSCPropNetPPPIdleReminder                SCSTR("IdleReminder")                    /* CFNumber (0 or 1) */
#define kSCPropNetPPPLastCause                   SCSTR("LastCause")                       /* CFNumber */
#define kSCPropNetPPPLogfile                     SCSTR("Logfile")                         /* CFString */
#define kSCPropNetPPPPlugins                     SCSTR("Plugins")                         /* CFArray[CFString] */
#define kSCPropNetPPPRetryConnectTime            SCSTR("RetryConnectTime")                /* CFNumber */
#define kSCPropNetPPPSessionTimer                SCSTR("SessionTimer")                    /* CFNumber */
#define kSCPropNetPPPStatus                      SCSTR("Status")                          /* CFNumber */
#define kSCPropNetPPPUseSessionTimer             SCSTR("UseSessionTimer")                 /* CFNumber (0 or 1) */
#define kSCPropNetPPPVerboseLogging              SCSTR("VerboseLogging")                  /* CFNumber (0 or 1) */

/* Auth: */
#define kSCPropNetPPPAuthEAPPlugins              SCSTR("AuthEAPPlugins")                  /* CFArray[CFString] */
#define kSCPropNetPPPAuthName                    SCSTR("AuthName")                        /* CFString */
#define kSCPropNetPPPAuthPassword                SCSTR("AuthPassword")                    /* CFString */
#define kSCPropNetPPPAuthPasswordEncryption      SCSTR("AuthPasswordEncryption")          /* CFString */
#define kSCPropNetPPPAuthPrompt                  SCSTR("AuthPrompt")                      /* CFString */
#define kSCPropNetPPPAuthProtocol                SCSTR("AuthProtocol")                    /* CFArray[CFString] */

/* kSCPropNetPPPAuthPasswordEncryption values */
#define kSCValNetPPPAuthPasswordEncryptionKeychain SCSTR("Keychain")                       

/* kSCPropNetPPPAuthPrompt values */
#define kSCValNetPPPAuthPromptBefore             SCSTR("Before")                          /* CFString */
#define kSCValNetPPPAuthPromptAfter              SCSTR("After")                           /* CFString */

/* kSCPropNetPPPAuthProtocol values */
#define kSCValNetPPPAuthProtocolCHAP             SCSTR("CHAP")                            /* CFString */
#define kSCValNetPPPAuthProtocolEAP              SCSTR("EAP")                             /* CFString */
#define kSCValNetPPPAuthProtocolMSCHAP1          SCSTR("MSCHAP1")                         /* CFString */
#define kSCValNetPPPAuthProtocolMSCHAP2          SCSTR("MSCHAP2")                         /* CFString */
#define kSCValNetPPPAuthProtocolPAP              SCSTR("PAP")                             /* CFString */

/* Comm: */
#define kSCPropNetPPPCommAlternateRemoteAddress  SCSTR("CommAlternateRemoteAddress")      /* CFString */
#define kSCPropNetPPPCommConnectDelay            SCSTR("CommConnectDelay")                /* CFNumber */
#define kSCPropNetPPPCommDisplayTerminalWindow   SCSTR("CommDisplayTerminalWindow")       /* CFNumber (0 or 1) */
#define kSCPropNetPPPCommRedialCount             SCSTR("CommRedialCount")                 /* CFNumber */
#define kSCPropNetPPPCommRedialEnabled           SCSTR("CommRedialEnabled")               /* CFNumber (0 or 1) */
#define kSCPropNetPPPCommRedialInterval          SCSTR("CommRedialInterval")              /* CFNumber */
#define kSCPropNetPPPCommRemoteAddress           SCSTR("CommRemoteAddress")               /* CFString */
#define kSCPropNetPPPCommTerminalScript          SCSTR("CommTerminalScript")              /* CFString */
#define kSCPropNetPPPCommUseTerminalScript       SCSTR("CommUseTerminalScript")           /* CFNumber (0 or 1) */

/* CCP: */
#define kSCPropNetPPPCCPEnabled                  SCSTR("CCPEnabled")                      /* CFNumber (0 or 1) */

/* IPCP: */
#define kSCPropNetPPPIPCPCompressionVJ           SCSTR("IPCPCompressionVJ")               /* CFNumber (0 or 1) */

/* LCP: */
#define kSCPropNetPPPLCPEchoEnabled              SCSTR("LCPEchoEnabled")                  /* CFNumber (0 or 1) */
#define kSCPropNetPPPLCPEchoFailure              SCSTR("LCPEchoFailure")                  /* CFNumber */
#define kSCPropNetPPPLCPEchoInterval             SCSTR("LCPEchoInterval")                 /* CFNumber */
#define kSCPropNetPPPLCPCompressionACField       SCSTR("LCPCompressionACField")           /* CFNumber (0 or 1) */
#define kSCPropNetPPPLCPCompressionPField        SCSTR("LCPCompressionPField")            /* CFNumber (0 or 1) */
#define kSCPropNetPPPLCPMRU                      SCSTR("LCPMRU")                          /* CFNumber */
#define kSCPropNetPPPLCPMTU                      SCSTR("LCPMTU")                          /* CFNumber */
#define kSCPropNetPPPLCPReceiveACCM              SCSTR("LCPReceiveACCM")                  /* CFNumber */
#define kSCPropNetPPPLCPTransmitACCM             SCSTR("LCPTransmitACCM")                 /* CFNumber */

/*
 * kSCEntNetPPPoE Entity Keys
 */
/* RESERVED FOR FUTURE USE */

/*
 * kSCEntNetPPPSerial Entity Keys
 */
/* RESERVED FOR FUTURE USE */

/*
 * kSCEntNetPPTP Entity Keys
 */
/* RESERVED FOR FUTURE USE */

/*
 * kSCEntNetL2TP Entity Keys
 */
#define kSCPropNetL2TPIPSecSharedSecret          SCSTR("IPSecSharedSecret")               /* CFString */
#define kSCPropNetL2TPIPSecSharedSecretEncryption SCSTR("IPSecSharedSecretEncryption")     /* CFString */
#define kSCPropNetL2TPTransport                  SCSTR("Transport")                       /* CFString */

/* kSCPropNetL2TPIPSecSharedSecretEncryption values */
#define kSCValNetL2TPIPSecSharedSecretEncryptionKeychain SCSTR("Keychain")                       

/* kSCPropNetL2TPTransport values */
#define kSCValNetL2TPTransportIP                 SCSTR("IP")                             
#define kSCValNetL2TPTransportIPSec              SCSTR("IPSec")                          

/*
 * kSCEntNetProxies Entity Keys
 */
#define kSCPropNetProxiesExceptionsList          SCSTR("ExceptionsList")                  /* CFArray[CFString] */
#define kSCPropNetProxiesFTPEnable               SCSTR("FTPEnable")                       /* CFNumber (0 or 1) */
#define kSCPropNetProxiesFTPPassive              SCSTR("FTPPassive")                      /* CFNumber (0 or 1) */
#define kSCPropNetProxiesFTPPort                 SCSTR("FTPPort")                         /* CFNumber */
#define kSCPropNetProxiesFTPProxy                SCSTR("FTPProxy")                        /* CFString */
#define kSCPropNetProxiesGopherEnable            SCSTR("GopherEnable")                    /* CFNumber (0 or 1) */
#define kSCPropNetProxiesGopherPort              SCSTR("GopherPort")                      /* CFNumber */
#define kSCPropNetProxiesGopherProxy             SCSTR("GopherProxy")                     /* CFString */
#define kSCPropNetProxiesHTTPEnable              SCSTR("HTTPEnable")                      /* CFNumber (0 or 1) */
#define kSCPropNetProxiesHTTPPort                SCSTR("HTTPPort")                        /* CFNumber */
#define kSCPropNetProxiesHTTPProxy               SCSTR("HTTPProxy")                       /* CFString */
#define kSCPropNetProxiesHTTPSEnable             SCSTR("HTTPSEnable")                     /* CFNumber (0 or 1) */
#define kSCPropNetProxiesHTTPSPort               SCSTR("HTTPSPort")                       /* CFNumber */
#define kSCPropNetProxiesHTTPSProxy              SCSTR("HTTPSProxy")                      /* CFString */
#define kSCPropNetProxiesRTSPEnable              SCSTR("RTSPEnable")                      /* CFNumber (0 or 1) */
#define kSCPropNetProxiesRTSPPort                SCSTR("RTSPPort")                        /* CFNumber */
#define kSCPropNetProxiesRTSPProxy               SCSTR("RTSPProxy")                       /* CFString */
#define kSCPropNetProxiesSOCKSEnable             SCSTR("SOCKSEnable")                     /* CFNumber (0 or 1) */
#define kSCPropNetProxiesSOCKSPort               SCSTR("SOCKSPort")                       /* CFNumber */
#define kSCPropNetProxiesSOCKSProxy              SCSTR("SOCKSProxy")                      /* CFString */
#define kSCPropNetProxiesProxyAutoConfigEnable   SCSTR("ProxyAutoConfigEnable")           /* CFNumber (0 or 1) */
#define kSCPropNetProxiesProxyAutoConfigURLString SCSTR("ProxyAutoConfigURLString")        /* CFString */

/*
 kSCCompUsers Entity Keys
 */
#define kSCEntUsersConsoleUser                   SCSTR("ConsoleUser")                    

/*
 * kSCCompSystem Properties
 */
#define kSCPropSystemComputerName                SCSTR("ComputerName")                    /* CFString */
#define kSCPropSystemComputerNameEncoding        SCSTR("ComputerNameEncoding")            /* CFNumber */

/*
 * Configuration Store Definitions
 */
/* domain prefixes */
#define kSCDynamicStoreDomainFile                SCSTR("File:")                          
#define kSCDynamicStoreDomainPlugin              SCSTR("Plugin:")                        
#define kSCDynamicStoreDomainSetup               SCSTR("Setup:")                         
#define kSCDynamicStoreDomainState               SCSTR("State:")                         
#define kSCDynamicStoreDomainPrefs               SCSTR("Prefs:")                         

/* kSCDynamicStoreDomainSetup Properties */
#define kSCDynamicStorePropSetupCurrentSet       SCSTR("CurrentSet")                      /* CFString */
#define kSCDynamicStorePropSetupLastUpdated      SCSTR("LastUpdated")                    

/* Properties */
#define kSCDynamicStorePropNetInterfaces         SCSTR("Interfaces")                      /* CFArray[CFString] */
#define kSCDynamicStorePropNetPrimaryInterface   SCSTR("PrimaryInterface")                /* CFString */
#define kSCDynamicStorePropNetPrimaryService     SCSTR("PrimaryService")                  /* CFString */
#define kSCDynamicStorePropNetServiceIDs         SCSTR("ServiceIDs")                      /* CFArray[CFString] */

/*
 * Obsolete schema definitions which will be removed "soon".
 */

#endif /* _SCSCHEMADEFINITIONS_10_1_H */
